-- ###########################################################################################
-- ### Lotto - Sessionversion ################################################################
-- ###########################################################################################
-- ### Anlage der Datenbank                                                                ###
-- ### ----------------------------------------------------------------------------------- ###
-- ### Dieses Skript legt die benoetigten Datenbank an.                                    ###
-- ### In den Zeilen 50 +52 sind die Pfadangaben individuell anzupassen!!!                 ###
-- ### ----------------------------------------------------------------------------------- ###
-- ### Sicherheitshinweis:                                                                 ###
-- ###      Ueber diese Befehlssammlung werden Datenbankobjekte angelegt, geaendert oder   ###
-- ###      geloescht. Auch koennen Inhalte hinzugefuegt, manipuliert oder entfernt        ###
-- ###      werden. In produktiven Umgebungen darf dieses Skript NICHT eingesetzt werden,  ###
-- ###      um versehentliche Auswirkungen auf sonstige Strukturen auszuschliessen.        ###
-- ###                                                                                     ###
-- ### Erstellung:                                                                         ###
-- ###      Torsten Ahlemeyer fuer arelium GmbH, www.arelium.de                            ###
-- ### ----------------------------------------------------------------------------------- ###
-- ### Aenderungsnachweis:                                                                 ###
-- ###     1.00.0	2022-07-26	Torsten Ahlemeyer                                          ###
-- ###              Initiale Erstellung mit Default-Werten                                 ###
-- ###########################################################################################



--------------------------------------------------------------------------------------------------
-- Statistiken -----------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------

-- temporaere Tabelle anlegen, um sich die Startzeit zu merken
BEGIN TRY
	DROP TABLE #Start
END TRY
BEGIN CATCH
END CATCH

CREATE TABLE #Start (StartTime DATETIME)
INSERT INTO #Start (StartTime) VALUES (GETDATE())



--------------------------------------------------------------------------------------------------
-- Nutzinhalt ------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------------
USE [master]
GO

CREATE DATABASE [Lotto]
 CONTAINMENT = NONE
 ON  PRIMARY 
( NAME = N'Lotto', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL15.MSSQLSERVER\MSSQL\DATA\Lotto.mdf' , SIZE = 8192KB , FILEGROWTH = 65536KB )
 LOG ON 
( NAME = N'Lotto_log', FILENAME = N'C:\Program Files\Microsoft SQL Server\MSSQL15.MSSQLSERVER\MSSQL\DATA\Lotto_log.ldf' , SIZE = 8192KB , FILEGROWTH = 65536KB )
GO
ALTER DATABASE [Lotto] SET COMPATIBILITY_LEVEL = 150
GO
ALTER DATABASE [Lotto] SET ANSI_NULL_DEFAULT OFF 
GO
ALTER DATABASE [Lotto] SET ANSI_NULLS OFF 
GO
ALTER DATABASE [Lotto] SET ANSI_PADDING OFF 
GO
ALTER DATABASE [Lotto] SET ANSI_WARNINGS OFF 
GO
ALTER DATABASE [Lotto] SET ARITHABORT OFF 
GO
ALTER DATABASE [Lotto] SET AUTO_CLOSE OFF 
GO
ALTER DATABASE [Lotto] SET AUTO_SHRINK OFF 
GO
ALTER DATABASE [Lotto] SET AUTO_CREATE_STATISTICS ON(INCREMENTAL = OFF)
GO
ALTER DATABASE [Lotto] SET AUTO_UPDATE_STATISTICS ON 
GO
ALTER DATABASE [Lotto] SET CURSOR_CLOSE_ON_COMMIT OFF 
GO
ALTER DATABASE [Lotto] SET CURSOR_DEFAULT  GLOBAL 
GO
ALTER DATABASE [Lotto] SET CONCAT_NULL_YIELDS_NULL OFF 
GO
ALTER DATABASE [Lotto] SET NUMERIC_ROUNDABORT OFF 
GO
ALTER DATABASE [Lotto] SET QUOTED_IDENTIFIER OFF 
GO
ALTER DATABASE [Lotto] SET RECURSIVE_TRIGGERS OFF 
GO
ALTER DATABASE [Lotto] SET  DISABLE_BROKER 
GO
ALTER DATABASE [Lotto] SET AUTO_UPDATE_STATISTICS_ASYNC OFF 
GO
ALTER DATABASE [Lotto] SET DATE_CORRELATION_OPTIMIZATION OFF 
GO
ALTER DATABASE [Lotto] SET PARAMETERIZATION SIMPLE 
GO
ALTER DATABASE [Lotto] SET READ_COMMITTED_SNAPSHOT OFF 
GO
ALTER DATABASE [Lotto] SET  READ_WRITE 
GO
ALTER DATABASE [Lotto] SET RECOVERY FULL 
GO
ALTER DATABASE [Lotto] SET  MULTI_USER 
GO
ALTER DATABASE [Lotto] SET PAGE_VERIFY CHECKSUM  
GO
ALTER DATABASE [Lotto] SET TARGET_RECOVERY_TIME = 60 SECONDS 
GO
ALTER DATABASE [Lotto] SET DELAYED_DURABILITY = DISABLED 
GO
USE [Lotto]
GO
ALTER DATABASE SCOPED CONFIGURATION SET LEGACY_CARDINALITY_ESTIMATION = Off;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET LEGACY_CARDINALITY_ESTIMATION = Primary;
GO
ALTER DATABASE SCOPED CONFIGURATION SET MAXDOP = 0;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET MAXDOP = PRIMARY;
GO
ALTER DATABASE SCOPED CONFIGURATION SET PARAMETER_SNIFFING = On;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET PARAMETER_SNIFFING = Primary;
GO
ALTER DATABASE SCOPED CONFIGURATION SET QUERY_OPTIMIZER_HOTFIXES = Off;
GO
ALTER DATABASE SCOPED CONFIGURATION FOR SECONDARY SET QUERY_OPTIMIZER_HOTFIXES = Primary;
GO
USE [Lotto]
GO
IF NOT EXISTS (SELECT name FROM sys.filegroups WHERE is_default=1 AND name = N'PRIMARY') ALTER DATABASE [Lotto] MODIFY FILEGROUP [PRIMARY] DEFAULT
GO
