-- ###########################################################################################
-- ### Lotto - Sessionversion ################################################################
-- ###########################################################################################
-- ### Dieses Skript fuellt Nachschlagetabellen und zeigt exemplarisch die Ziehung eines   ###
-- ### Spieltages.                                                                         ###
-- ### ----------------------------------------------------------------------------------- ###
-- ### Sicherheitshinweis:                                                                 ###
-- ###      Ueber diese Befehlssammlung werden Datenbankobjekte angelegt, geaendert oder   ###
-- ###      geloescht. Auch koennen Inhalte hinzugefuegt, manipuliert oder entfernt        ###
-- ###      werden. In produktiven Umgebungen darf dieses Skript NICHT eingesetzt werden,  ###
-- ###      um versehentliche Auswirkungen auf sonstige Strukturen auszuschliessen.        ###
-- ###                                                                                     ###
-- ### Erstellung:                                                                         ###
-- ###      Torsten Ahlemeyer fuer arelium GmbH, www.arelium.de                            ###
-- ### ----------------------------------------------------------------------------------- ###
-- ### Aenderungsnachweis:                                                                 ###
-- ###     1.00.0	2022-07-26	Torsten Ahlemeyer                                          ###
-- ###              Initiale Erstellung mit Default-Werten                                 ###
-- ###########################################################################################


USE [Lotto]
GO

-- Statt alle denkbaren Kombinationen ber verschachtelte Schleifen zu ermitteln (oder sogar
-- ineffiziente Cursor fr diese Aufgabe zu nutzen), kann man alle Kombinationen per
-- INNER JOIN zusmamenstellen. Dazu joint man 6x dieselbe Tabelle zusammen und sorgt ber die 
-- ON-Einschrnkung nur dafr, dass keine Zahl doppelt vorkommt und die Zahlen gleich in einer 
-- nach Gre aufsteigenden Ordnung notiert werden.

DROP TABLE IF EXISTS [Lotto].[Moeglichkeiten]
GO

SELECT 
	  [Z1].[Wert]					AS [Zahl01]
	, [Z2].[Wert]					AS [Zahl02]
	, [Z3].[Wert]					AS [Zahl03]
	, [Z4].[Wert]					AS [Zahl04]
	, [Z5].[Wert]					AS [Zahl05]
	, [Z6].[Wert]					AS [Zahl06]
	, [SZ].[Wert]					AS [Superzahl]
INTO [Lotto].[Moeglichkeiten]
FROM [Lotto].[Normzahlen]			AS [Z1]
INNER JOIN [Lotto].[Normzahlen]		AS [Z2] ON [Z1].[Wert] < [Z2].[Wert]
INNER JOIN [Lotto].[Normzahlen]		AS [Z3] ON [Z2].[Wert] < [Z3].[Wert]
INNER JOIN [Lotto].[Normzahlen]		AS [Z4] ON [Z3].[Wert] < [Z4].[Wert]
INNER JOIN [Lotto].[Normzahlen]		AS [Z5] ON [Z4].[Wert] < [Z5].[Wert]
INNER JOIN [Lotto].[Normzahlen]		AS [Z6] ON [Z5].[Wert] < [Z6].[Wert]
CROSS JOIN [Lotto].[Superzahlen]	AS [SZ]



-- Eine zufllige Ziehung der Lotterie 6 aus 49 inklusive der Zusatzzahl ermitteln:
SELECT
	TOP (1)
	[Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06], [Superzahl]
FROM [Lotto].[Moeglichkeiten]
ORDER BY NEWID()

