USE [msdb]
GO

/****** Object:  Job [[Lotto].[jobZiehungenMittwochUndSonntag]]    Script Date: 31.07.2022 13:34:32 ******/
BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0
/****** Object:  JobCategory [[Uncategorized (Local)]]    Script Date: 31.07.2022 13:34:33 ******/
IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'[Lotto].[jobZiehungenMittwochUndSonntag]', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'DESKTOP-OGDDQAL\Torst', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
/****** Object:  Step [Einzelziehung]    Script Date: 31.07.2022 13:34:33 ******/
EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Einzelziehung', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE [Lotto]
GO


DECLARE @DatumLetzteZiehung			AS DATE
DECLARE @WochentagLetzteZiehung		AS INTEGER
SET @DatumLetzteZiehung = ISNULL((SELECT TOP(1) [Datum] FROM [Lotto].[Ziehungen] ORDER BY [Datum] DESC), ''19551005'')

-- 1 = Montag
-- 2 = Dienstag
-- ...
-- 7 = Sonntag
SET @WochentagLetzteZiehung = (@@DATEFIRST + DATEPART(weekday, @DatumLetzteZiehung) - 1) % 7;
SET @WochentagLetzteZiehung = CASE WHEN @WochentagLetzteZiehung = 0 THEN 7 ELSE @WochentagLetzteZiehung END; -- Sonntag ist 0 bei der obigen Berechnung und wird auf die SQL interne Nummer umgestellt


DECLARE @DatumAktuelleZiehung		AS DATE
DECLARE @WochentagAktuelleZiehung	AS INTEGER
SELECT @DatumAktuelleZiehung = CASE @WochentagLetzteZiehung 
									WHEN 7 THEN DATEADD(DAY, 3, @DatumLetzteZiehung) 
									ELSE		DATEADD(DAY, 4, @DatumLetzteZiehung)
								END
SET @WochentagAktuelleZiehung = (@@DATEFIRST + DATEPART(weekday, @DatumAktuelleZiehung) - 1) % 7;
SET @WochentagAktuelleZiehung = CASE WHEN @WochentagAktuelleZiehung = 0 THEN 7 ELSE @WochentagAktuelleZiehung END; -- Sonntag ist 0 bei der obigen Berechnung und wird auf die SQL interne Nummer umgestellt

INSERT INTO [Lotto].[Ziehungen]
           (
             [Datum]
           , [Wochentag]
           , [Zahl01]
           , [Zahl02]
           , [Zahl03]
           , [Zahl04]
           , [Zahl05]
           , [Zahl06]
           , [Zusatzzahl])
SELECT 
	  @DatumAktuelleZiehung				AS [Datum]
	, CASE @WochentagAktuelleZiehung
			WHEN 3 THEN ''Mittwoch''
			WHEN 7 THEN ''Sonntag''
			ELSE ''Fehler''
		END								AS [Wochentag]
	, [Rechts].[Zahl01]					AS [Zahl01]					
	, [Rechts].[Zahl02]					AS [Zahl02]
	, [Rechts].[Zahl03]					AS [Zahl03]
	, [Rechts].[Zahl04]					AS [Zahl04]
	, [Rechts].[Zahl05]					AS [Zahl05]
	, [Rechts].[Zahl06]					AS [Zahl06]
	, [Rechts].[Superzahl]				AS [Superzahl]
FROM 
	(SELECT
		TOP (1)
		[Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06], [Superzahl]
	FROM [Lotto].[Moeglichkeiten]
	ORDER BY NEWID()
	) AS [RECHTS]
GO
 ', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'Alle3MinutenEineZiehung', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=3, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20220731, 
		@active_end_date=20220831, 
		@active_start_time=0, 
		@active_end_time=235959, 
		@schedule_uid=N'2acaea2e-1f16-4de4-bd6c-a7a84a37aab1'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO

