USE [Lotto]
GO


-- es sollen Zufallstipps von tausenden von Spielern simuliert werden. Diese sollen (ebenfalls zufllig) auf 
-- insgesamt 4 verschiedene Daten verteilt werden (2 x Mittwoch, 2 x Sonntag)


DECLARE @DatumAktuelleZiehung		AS DATE
DECLARE @WochentagAktuelleZiehung	AS INTEGER

SET @DatumAktuelleZiehung			= (	SELECT TOP(1) [Datum] 
										FROM (	SELECT TOP 4 [Datum]
												FROM [Lotto].[Ziehungen] 
												ORDER BY [Datum] ASC)	AS [Dummy]
										ORDER BY NEWID())
SET @WochentagAktuelleZiehung		= (@@DATEFIRST + DATEPART(weekday, @DatumAktuelleZiehung) - 1) % 7;
SET @WochentagAktuelleZiehung		= CASE WHEN @WochentagAktuelleZiehung = 0 THEN 7 ELSE @WochentagAktuelleZiehung END; -- Sonntag ist 0 bei der obigen Berechnung und wird auf die SQL interne Nummer umgestellt


--INSERT INTO [Lotto].[Tipps]
--           (
--             [Datum]
--           , [Wochentag]
--           , [Zahl01]
--           , [Zahl02]
--           , [Zahl03]
--           , [Zahl04]
--           , [Zahl05]
--           , [Zahl06]
--           , [Zusatzzahl])
SELECT 
	  @DatumAktuelleZiehung				AS [Datum]
	, CASE @WochentagAktuelleZiehung
			WHEN 3 THEN 'Mittwoch'
			WHEN 7 THEN 'Sonntag'
			ELSE 'Fehler'
		END								AS [Wochentag]
	, [Rechts].[Zahl01]					AS [Zahl01]					
	, [Rechts].[Zahl02]					AS [Zahl02]
	, [Rechts].[Zahl03]					AS [Zahl03]
	, [Rechts].[Zahl04]					AS [Zahl04]
	, [Rechts].[Zahl05]					AS [Zahl05]
	, [Rechts].[Zahl06]					AS [Zahl06]
	, [Rechts].[Superzahl]				AS [Superzahl]
FROM 
	(SELECT
		TOP (1)
		[Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06], [Superzahl]
	FROM [Lotto].[Moeglichkeiten]
	ORDER BY NEWID()
	) AS [RECHTS]
GO
 






 
-- auerdem soll es ein zustzlich kleinere Gruppe von Spielern geben, die sich bevorzugt von Geburtstagen
-- inspirieren laesst. Diese Gruppe spielt nur mittwochs. 

DECLARE @DatumAktuelleZiehung		AS DATE
DECLARE @WochentagAktuelleZiehung	AS INTEGER

SET @DatumAktuelleZiehung			= (	SELECT TOP(1) [Datum] 
										FROM (	SELECT TOP 2 [Datum]
												FROM [Lotto].[Ziehungen] 
												WHERE [Wochentag] = 'Mittwoch  '
												ORDER BY [Datum] ASC)	AS [Dummy]
										ORDER BY NEWID())
SET @WochentagAktuelleZiehung		= (@@DATEFIRST + DATEPART(weekday, @DatumAktuelleZiehung) - 1) % 7;
SET @WochentagAktuelleZiehung		= CASE WHEN @WochentagAktuelleZiehung = 0 THEN 7 ELSE @WochentagAktuelleZiehung END; -- Sonntag ist 0 bei der obigen Berechnung und wird auf die SQL interne Nummer umgestellt


--INSERT INTO [Lotto].[Tipps]
--           (
--             [Datum]
--           , [Wochentag]
--           , [Zahl01]
--           , [Zahl02]
--           , [Zahl03]
--           , [Zahl04]
--           , [Zahl05]
--           , [Zahl06]
--           , [Zusatzzahl])
SELECT 
	  @DatumAktuelleZiehung				AS [Datum]
	, 'Mittwoch  '						AS [Wochentag]
	, [Rechts].[Zahl01]					AS [Zahl01]					
	, [Rechts].[Zahl02]					AS [Zahl02]
	, [Rechts].[Zahl03]					AS [Zahl03]
	, [Rechts].[Zahl04]					AS [Zahl04]
	, [Rechts].[Zahl05]					AS [Zahl05]
	, [Rechts].[Zahl06]					AS [Zahl06]
	, [Rechts].[Superzahl]				AS [Superzahl]
FROM 
	(SELECT
		TOP (1)
		[Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06], [Superzahl]
	FROM [Lotto].[Moeglichkeiten]
	WHERE 1 = 1
		AND [Zahl01] <= 12
		AND [Zahl02] <= 12
		AND [Zahl03] <= 12
		AND [Zahl04] <= 31
		AND [Zahl05] <= 31
		AND [Zahl06] <= 31
	ORDER BY NEWID()
	) AS [RECHTS]
GO
 