USE [msdb]
GO

IF EXISTS (SELECT job_id FROM msdb.dbo.sysjobs WHERE (name = N'[Lotto].[jobTippsNormalos]'))
	EXEC msdb.dbo.sp_delete_job @job_name = N'[Lotto].[jobTippsNormalos]', @delete_unused_schedule=1
GO

BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'[Lotto].[jobTippsNormalos]', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'zufaelligen Tipp abgeben', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE [Lotto]
GO


-- es sollen Zufallstipps von tausenden von Spielern simuliert werden. Diese sollen (ebenfalls zufllig) auf 
-- insgesamt 4 verschiedene Daten verteilt werden (2 x Mittwoch, 2 x Sonntag)


DECLARE @DatumAktuelleZiehung		AS DATE
DECLARE @WochentagAktuelleZiehung	AS INTEGER

SET @DatumAktuelleZiehung			= (	SELECT TOP(1) [Datum] 
										FROM (	SELECT TOP 4 [Datum]
												FROM [Lotto].[Ziehungen] 
												ORDER BY [Datum] ASC)	AS [Dummy]
										ORDER BY NEWID())
SET @WochentagAktuelleZiehung		= (@@DATEFIRST + DATEPART(weekday, @DatumAktuelleZiehung) - 1) % 7;
SET @WochentagAktuelleZiehung		= CASE WHEN @WochentagAktuelleZiehung = 0 THEN 7 ELSE @WochentagAktuelleZiehung END; -- Sonntag ist 0 bei der obigen Berechnung und wird auf die SQL interne Nummer umgestellt


INSERT INTO [Lotto].[Tipps]
           (
             [Datum]
           , [Wochentag]
           , [Zahl01]
           , [Zahl02]
           , [Zahl03]
           , [Zahl04]
           , [Zahl05]
           , [Zahl06]
           , [Zusatzzahl])
SELECT 
	  @DatumAktuelleZiehung				AS [Datum]
	, CASE @WochentagAktuelleZiehung
			WHEN 3 THEN ''Mittwoch''
			WHEN 7 THEN ''Sonntag''
			ELSE ''Fehler''
		END								AS [Wochentag]
	, [Rechts].[Zahl01]					AS [Zahl01]					
	, [Rechts].[Zahl02]					AS [Zahl02]
	, [Rechts].[Zahl03]					AS [Zahl03]
	, [Rechts].[Zahl04]					AS [Zahl04]
	, [Rechts].[Zahl05]					AS [Zahl05]
	, [Rechts].[Zahl06]					AS [Zahl06]
	, [Rechts].[Superzahl]				AS [Superzahl]
FROM 
	(SELECT
		TOP (1)
		[Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06], [Superzahl]
	FROM [Lotto].[Moeglichkeiten]
	ORDER BY NEWID()
	) AS [RECHTS]
GO
 
', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'3TippsProMinute', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=2, 
		@freq_subday_interval=20, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20220802, 
		@active_end_date=20221102, 
		@active_start_time=0, 
		@active_end_time=235959, 
		@schedule_uid=N'b341e14b-e980-4c13-a8a2-f60ab282afc0'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO



























USE [msdb]
GO

IF EXISTS (SELECT job_id FROM msdb.dbo.sysjobs WHERE (name = N'[Lotto].[jobTippsGeburtstagsfaible]'))
	EXEC msdb.dbo.sp_delete_job @job_name = N'[Lotto].[jobTippsGeburtstagsfaible]', @delete_unused_schedule=1
GO

BEGIN TRANSACTION
DECLARE @ReturnCode INT
SELECT @ReturnCode = 0

IF NOT EXISTS (SELECT name FROM msdb.dbo.syscategories WHERE name=N'[Uncategorized (Local)]' AND category_class=1)
BEGIN
EXEC @ReturnCode = msdb.dbo.sp_add_category @class=N'JOB', @type=N'LOCAL', @name=N'[Uncategorized (Local)]'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

END

DECLARE @jobId BINARY(16)
EXEC @ReturnCode =  msdb.dbo.sp_add_job @job_name=N'[Lotto].[jobTippsGeburtstagsfaible]', 
		@enabled=1, 
		@notify_level_eventlog=0, 
		@notify_level_email=0, 
		@notify_level_netsend=0, 
		@notify_level_page=0, 
		@delete_level=0, 
		@description=N'No description available.', 
		@category_name=N'[Uncategorized (Local)]', 
		@owner_login_name=N'sa', @job_id = @jobId OUTPUT
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback

EXEC @ReturnCode = msdb.dbo.sp_add_jobstep @job_id=@jobId, @step_name=N'Tipp generieren und abspeichern', 
		@step_id=1, 
		@cmdexec_success_code=0, 
		@on_success_action=1, 
		@on_success_step_id=0, 
		@on_fail_action=2, 
		@on_fail_step_id=0, 
		@retry_attempts=0, 
		@retry_interval=0, 
		@os_run_priority=0, @subsystem=N'TSQL', 
		@command=N'USE [Lotto]
GO

DECLARE @DatumAktuelleZiehung		AS DATE
DECLARE @WochentagAktuelleZiehung	AS INTEGER

SET @DatumAktuelleZiehung			= (	SELECT TOP(1) [Datum] 
										FROM (	SELECT TOP 2 [Datum]
												FROM [Lotto].[Ziehungen] 
												WHERE [Wochentag] = ''Mittwoch  ''
												ORDER BY [Datum] ASC)	AS [Dummy]
										ORDER BY NEWID())
SET @WochentagAktuelleZiehung		= (@@DATEFIRST + DATEPART(weekday, @DatumAktuelleZiehung) - 1) % 7;
SET @WochentagAktuelleZiehung		= CASE WHEN @WochentagAktuelleZiehung = 0 THEN 7 ELSE @WochentagAktuelleZiehung END; -- Sonntag ist 0 bei der obigen Berechnung und wird auf die SQL interne Nummer umgestellt


INSERT INTO [Lotto].[Tipps]
           (
             [Datum]
           , [Wochentag]
           , [Zahl02]
           , [Zahl03]
           , [Zahl01]
           , [Zahl04]
           , [Zahl05]
           , [Zahl06]
           , [Zusatzzahl])
SELECT 
	  @DatumAktuelleZiehung				AS [Datum]
	, ''Mittwoch  ''						AS [Wochentag]
	, [Rechts].[Zahl01]					AS [Zahl01]					
	, [Rechts].[Zahl02]					AS [Zahl02]
	, [Rechts].[Zahl03]					AS [Zahl03]
	, [Rechts].[Zahl04]					AS [Zahl04]
	, [Rechts].[Zahl05]					AS [Zahl05]
	, [Rechts].[Zahl06]					AS [Zahl06]
	, [Rechts].[Superzahl]				AS [Superzahl]
FROM 
	(SELECT
		TOP (1)
		[Zahl01], [Zahl02], [Zahl03], [Zahl04], [Zahl05], [Zahl06], [Superzahl]
	FROM [Lotto].[Moeglichkeiten]
	WHERE 1 = 1
		AND [Zahl01] <= 12
		AND [Zahl02] <= 12
		AND [Zahl03] <= 12
		AND [Zahl04] <= 31
		AND [Zahl05] <= 31
		AND [Zahl06] <= 31
	ORDER BY NEWID()
	) AS [RECHTS]
GO
', 
		@database_name=N'master', 
		@flags=0
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_update_job @job_id = @jobId, @start_step_id = 1
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobschedule @job_id=@jobId, @name=N'JedeMinuteEinTipp', 
		@enabled=1, 
		@freq_type=4, 
		@freq_interval=1, 
		@freq_subday_type=4, 
		@freq_subday_interval=1, 
		@freq_relative_interval=0, 
		@freq_recurrence_factor=0, 
		@active_start_date=20220802, 
		@active_end_date=20221102, 
		@active_start_time=0, 
		@active_end_time=235959, 
		@schedule_uid=N'810bdfa7-1d53-46e1-b7d0-555d208aa390'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
EXEC @ReturnCode = msdb.dbo.sp_add_jobserver @job_id = @jobId, @server_name = N'(local)'
IF (@@ERROR <> 0 OR @ReturnCode <> 0) GOTO QuitWithRollback
COMMIT TRANSACTION
GOTO EndSave
QuitWithRollback:
    IF (@@TRANCOUNT > 0) ROLLBACK TRANSACTION
EndSave:
GO

